# AtkAction

## Name

AtkAction -- The ATK interface provided by UI components which the user can activate/interact with,

## Synopsis

    struct      AtkAction;
    gboolean    atk_action_do_action            (AtkAction *action,
                                                 gint i);
    gint        atk_action_get_n_actions        (AtkAction *action);
    G_CONST_RETURN gchar* atk_action_get_description
                                                (AtkAction *action,
                                                 gint i);
    G_CONST_RETURN gchar* atk_action_get_name   (AtkAction *action,
                                                 gint i);
    G_CONST_RETURN gchar* atk_action_get_localized_name
                                                (AtkAction *action,
                                                 gint i);
    G_CONST_RETURN gchar* atk_action_get_keybinding
                                                (AtkAction *action,
                                                 gint i);
    gboolean    atk_action_set_description      (AtkAction *action,
                                                 gint i,
                                                 const gchar *desc);

## Object Hierarchy

      GInterface
       +----AtkAction

## Implementations

AtkAction is implemented by AtkNoOpObject and AtkHyperlink.

## Description

AtkAction should be implemented by instances of AtkObject classes with which the user can interact directly, i.e. buttons, checkboxes, scrollbars, e.g. components which are not "passive" providers of UI information.

Exceptions: when the user interaction is already covered by another appropriate interface such as AtkEditableText (insert/delete test, etc.) or AtkValue (set value) then these actions should not be exposed by AtkAction as well.

Also note that the AtkAction API is limited in that parameters may not be passed to the object being activated; thus the action must be self-contained and specifiable via only a single "verb". Concrete examples include "press", "release", "click" for buttons, "drag" (meaning initiate drag) and "drop" for drag sources and drop targets, etc.

Though most UI interactions on components should be invocable via keyboard as well as mouse, there will generally be a close mapping between "mouse actions" that are possible on a component and the AtkActions. Where mouse and keyboard actions are redundant in effect, AtkAction should expose only one action rather than exposing redundant actions if possible. By convention we have been using "mouse centric" terminology for AtkAction names.

## Details

### struct AtkAction

    struct AtkAction;

The AtkAction structure does not contain any fields.

### atk_action_do_action ()

    gboolean    atk_action_do_action            (AtkAction *action,
                                                 gint i);

Perform the specified action on the object.

`action` :

  a GObject instance that implements AtkActionIface

`i` :

  the action index corresponding to the action to be performed

Returns :

  `TRUE` if success, `FALSE` otherwise

### atk_action_get_n_actions ()

    gint        atk_action_get_n_actions        (AtkAction *action);

Gets the number of accessible actions available on the object. If there are more than one, the first one is considered the "default" action of the object.

`action` :

  a GObject instance that implements AtkActionIface

Returns :

  a the number of actions, or 0 if `action` does not implement this interface.

### atk_action_get_description ()

    G_CONST_RETURN gchar* atk_action_get_description
                                                (AtkAction *action,
                                                 gint i);

Returns a description of the specified action of the object.

`action` :

  a GObject instance that implements AtkActionIface

`i` :

  the action index corresponding to the action to be performed

Returns :

  a description string, or `NULL` if `action` does not implement this interface.

### atk_action_get_name ()

    G_CONST_RETURN gchar* atk_action_get_name   (AtkAction *action,
                                                 gint i);

Returns the name of the specified action of the object.

`action` :

  a GObject instance that implements AtkActionIface

`i` :

  the action index corresponding to the action to be performed

Returns :

  a name string, or `NULL` if `action` does not implement this interface.

### atk_action_get_localized_name ()

    G_CONST_RETURN gchar* atk_action_get_localized_name
                                                (AtkAction *action,
                                                 gint i);

Returns the localized name of the specified action of the object.

`action` :

  a GObject instance that implements AtkActionIface

`i` :

  the action index corresponding to the action to be performed

Returns :

  a name string, or `NULL` if `action` does not implement this interface.

### atk_action_get_keybinding ()

    G_CONST_RETURN gchar* atk_action_get_keybinding
                                                (AtkAction *action,
                                                 gint i);

Returns a keybinding associated with this action, if one exists.

`action` :

  a GObject instance that implements AtkActionIface

`i` :

  the action index corresponding to the action to be performed

Returns :

  a string representing the keybinding, or `NULL` if there is no keybinding for this action.

### atk_action_set_description ()

    gboolean    atk_action_set_description      (AtkAction *action,
                                                 gint i,
                                                 const gchar *desc);

Sets a description of the specified action of the object.

`action` :

  a GObject instance that implements AtkActionIface

`i` :

  the action index corresponding to the action to be performed

`desc` :

  the description to be assigned to this action

Returns :

  a gboolean representing if the description was successfully set;